#needsrootforbuild
Name:		iproute
Version:	5.15.0
Epoch:      1
Release:	18
Summary:	Linux network configuration utilities
License:	GPLv2+ and Public Domain
URL:		https://kernel.org/pub/linux/utils/net/iproute2/
Source0:	https://mirrors.edge.kernel.org/pub/linux/utils/net/iproute2/iproute2-%{version}.tar.xz

Patch1:         bugfix-iproute2-3.10.0-fix-maddr-show.patch         
Patch2:         bugfix-iproute2-change-proc-to-ipnetnsproc-which-is-private.patch

Patch6000:      backport-devlink-fix-devlink-health-dump-command-without-arg.patch
Patch6001:      backport-ip-Fix-size_columns-for-very-large-values.patch
Patch6002:      backport-ip-Fix-size_columns-invocation-that-passes-a-32-bit-.patch
Patch6003:      backport-l2tp-fix-typo-in-AF_INET6-checksum-JSON-print.patch
Patch6004:      backport-libnetlink-fix-socket-leak-in-rtnl_open_byproto.patch
Patch6005:      backport-lnstat-fix-buffer-overflow-in-header-output.patch
Patch6006:      backport-lnstat-fix-strdup-leak-in-w-argument-parsing.patch
Patch6007:      backport-q_cake-allow-changing-to-diffserv3.patch
Patch6008:      backport-tc-em_u32-fix-offset-parsing.patch
Patch6009:      backport-tc-flower-Fix-buffer-overflow-on-large-labels.patch
Patch6010:      backport-tc_util-Fix-parsing-action-control-with-space-and-sl.patch
Patch6011:      backport-tipc-fix-keylen-check.patch

Patch6012:      backport-bridge-Fix-memory-leak-when-doing-fdb-get.patch
Patch6013:      backport-ip-address-Fix-memory-leak-when-specifying-device.patch
Patch6014:      backport-ip-neigh-Fix-memory-leak-when-doing-get.patch
Patch6015:      backport-mptcp-Fix-memory-leak-when-doing-endpoint-show.patch
Patch6016:      backport-mptcp-Fix-memory-leak-when-getting-limits.patch
Patch6017:      backport-iptunnel-detect-protocol-mismatch-on-tunnel-change.patch
Patch6018:      backport-ipnetns-fix-fd-leak-with-ip-netns-set.patch
Patch6019:      backport-iproute2-optimize-code-and-fix-some-mem-leak-risk.patch
Patch6020:      backport-ipmaddr-fix-dereference-of-NULL-on-malloc-failure.patch
Patch6021:      backport-iproute_lwtunnel-fix-possible-use-of-NULL-when-mallo.patch
Patch6022:      backport-tc_util-fix-unitialized-warning.patch
Patch6023:      backport-tc_exec-don-t-dereference-NULL-on-calloc-failure.patch
Patch6024:      backport-m_action-fix-warning-of-overwrite-of-const-string.patch
Patch6025:      backport-netem-fix-NULL-deref-on-allocation-failure.patch
Patch6026:      backport-nstat-fix-potential-NULL-deref.patch
Patch6027:      backport-rdma-utils-fix-some-analyzer-warnings.patch
Patch6028:      backport-tc-prio-handle-possible-truncated-kernel-response.patch
Patch6029:      backport-iproute_lwtunnel-fix-array-boundary-check.patch
Patch6030:      backport-rt_names-check-for-malloc-failure.patch
Patch6031:      backport-tc_util-Fix-no-error-return-when-large-parent-id-used.patch
Patch6032:      backport-tc_util-Change-datatype-for-maj-to-avoid-overflow-issue.patch
Patch6033:      backport-tc-ct-Fix-invalid-pointer-dereference.patch
Patch6034:      backport-libnetlink-Fix-memory-leak-in-__rtnl_talk_iov.patch
Patch6035:      backport-xfrm-prepare-state-offload-logic-to-set-mode.patch

Patch6036:      backport-Add-get_long-utility-and-adapt-get_integer-accordingly.patch
Patch6037:      backport-Add-utility-to-convert-an-unsigned-int-to-string.patch
Patch6038:      backport-f_flower-Treat-port-0-as-valid.patch
Patch6039:      backport-ip-error-out-if-iplink-does-not-consume-all-options.patch
Patch6040:      backport-iplink_bridge-fix-incorrect-root-id-dump.patch
Patch6041:      backport-ss-change-aafilter-port-from-int-to-long-inode-support.patch
Patch6042:      backport-ss-Fix-socket-type-check-in-packet_show_line.patch
Patch6043:      backport-ss-print-unix-socket-ports-as-unsigned-int-inode.patch
Patch6044:      backport-utils-fix-get_integer-logic.patch

Patch9000:      feature-iproute-add-support-for-ipvlan-l2e-mode.patch
Patch9001:      bugfix-iproute2-cancel-some-test-cases.patch
Patch9002:      feature-iproute2-supports-to-parse-UB-device-and-related-display-of-vf-address.patch
Patch9003:      sync-ipvlan_mode-enum-with-kernel-headers.patch

BuildRequires:	gcc bison elfutils-libelf-devel flex iptables-devel
BuildRequires:  libmnl-devel libselinux-devel pkgconfig libbpf-devel sudo make
Requires:       libbpf psmisc

Provides:       /sbin/ip iproute-tc tc 
Obsoletes:      iproute-tc 

%description
Iproute2 is a collection of user-space utilities to set up networking
under Linux from the command-line. It can inspect and configure,
among other things: interface paramters, IP addresses, routing,
tunnels, bridges, packet transformations (IPsec, etc.), and Quality
of Service.

%package        devel
Summary:        Header files for iprout2
License:        GPLv2+
Provides:       iproute-static = %{version}-%{release}
Obsoletes:      iproute-static < %{version}-%{release}

%description    devel
Header files for iprout2

%package_help

%prep
%autosetup -n %{name}2-%{version} -p1

%build
export LIBDIR='%{_libdir}'
export IPT_LIB_DIR='/%{_lib}/xtables'
%configure --support_ub on
%make_build

%check
make check
if test -n "$(find . -name *.err)"; then
	echo "make check failed, please check"
	exit 1
fi

%install
export CONFDIR='%{_sysconfdir}/iproute2'
export SBINDIR='%{_sbindir}'
export LIBDIR='%{_libdir}'
export DOCDIR='%{_docdir}'

%make_install 

install -m 0755 -d %{buildroot}%{_includedir}
install -m 0644 include/libnetlink.h %{buildroot}%{_includedir}/libnetlink.h
install -m 0644 lib/libnetlink.a %{buildroot}%{_libdir}/libnetlink.a

%files
%defattr(-,root,root)
%license COPYING
%doc README
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/iproute2/*
%{_sbindir}/*
%{_libdir}/tc/*
%{_datadir}/bash-completion/completions/*

%files         devel
%defattr(-,root,root)
%license COPYING
%{_libdir}/libnetlink.a
%{_includedir}/*

%files         help
%defattr(-,root,root)
%doc README
%{_mandir}/*

%changelog
* Fri Jan 12 2024 liubo <liubo335@huawei.com> - 1:5.15.0-18
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:f_flower: Treat port 0 as valid
       ip: error out if iplink does not consume all options
       iplink_bridge: fix incorrect root id dump
       ss: change aafilter port from int to long (inode support)
       ss: Fix socket type check in packet_show_line()
       ss: print unix socket "ports" as unsigned int (inode)
       Add utility to convert an unsigned int to string
       Add get_long utility and adapt get_integer accordingly
       utils: fix get_integer() logic

* Mon Nov 27 2023 liubo <liubo335@huawei.com> - 1:5.15.0-17
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:libnetlink: Fix memory leak in __rtnl_talk_iov()
       tc: ct: Fix invalid pointer dereference
       tc_util: Change datatype for maj to avoid overflow issue
       tc_util: Fix no error return when large parent id used
       xfrm: prepare state offload logic to set mode

* Mon Nov 27 2023 liubo <liubo335@huawei.com> - 1:5.15.0-16
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: sync ipvlan_mode enum with kernel-headers

* Sat Nov 25 2023 mufengyan <mufengyan@hisilicon.com> - 1:5.15.0-15
- Type:feature
- ID:NA
- SUG:NA
- DESC:This patch adds ARPHRD_UB for iproute2 and support name
       parse for it and deletes the display of vf address
       information in the pf

* Thu Aug 17 2023 gaoxingwang <gaoxingwang1@huawei.com> - 1:5.15.0-14
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:ipnetns: fix fd leak with 'ip netns set'
       iproute2: optimize code and fix some mem-leak risk
       iproute_lwtunnel: fix array boundary check
       iproute_lwtunnel: fix possible use of NULL when malloc()
       m_action: fix warning of overwrite of const string
       netem: fix NULL deref on allocation failure
       nstat: fix potential NULL deref
       rdma/utils: fix some analyzer warnings
       rt_names: check for malloc() failure
       tc/prio: handle possible truncated kernel response
       tc_exec: don't dereference NULL on calloc failure
       tc_util fix unitialized warning
       iptunnel: detect protocol mismatch on tunnel change
       ipmaddr: fix dereference of NULL on malloc() failure

* Thu Mar 02 2023 jiangheng <jiangheng14@huawei.com> - 1:5.15.0-13
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix ip netns attach failed

* Fri Feb 17 2023 gaoxingwang <gaoxingwang1@huawei.com> - 1:5.15.0-12
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add BuildRequire for make to fix build failure

* Wed Feb 8 2023 gaoxingwang <gaoxingwang1@huawei.com> - 1:5.15.0-11
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add epoch version in changelog to fix check_spec_file ci failure  

* Wed Feb 1 2023 gaoxingwang <gaoxingwang1@huawei.com> - 5.15.0-10
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add epoch version

* Thu Dec 22 2022 gaoxingwang <gaoxingwang1@huawei.com> - 5.15.0-9
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:cancel some test cases that failed due to host configure

* Wed Dec 21 2022 gaoxingwang <gaoxingwang1@huawei.com> - 5.15.0-8
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:cancle man page check

* Mon Nov 21 2022 gaoxingwang <gaoxingwang1@huawei.com> - 5.15.0-7
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:enable make check

* Wed Nov 09 2022 jiangheng <jiangheng14@huawei.com> - 5.15.0-6
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add ipvlan l2e mode support

* Mon Oct 10 2022 jiangheng<jiangheng14@huawei.com> - 5.15.0-5
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:bridge: fix memory leak when doing fdb get
       mptcp: fix memory leak when doing 'endpoint show'
       mptcp: fix memory leak when getting limits
       ip neigh: fix memory leak when doing 'get'
       ip address: fix memory leak when specifying device
       fix marco expansion in changelog

* Fri Aug 26 2022 sunsuwan<sunsuwan3@huawei.com> - 5.15.0-4
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:lnstat: fix buffer overflow in header output 
       libnetlink: fix socket leak in rtnl_open_byptoyo
       lnstat: fix strdup leak in w argument parsing
       q_cake: allow fix buffer overflow on large labels
       tc flower: fix buffer overflow on large labels
       tc_tuil: fix parsing action control with space and sl
       tipc: fix keylen check
       fix devlink health dump command without arg
       tc: em_u32: fix offset parsing
       l2tp fix typo in AF_INET6 checksum JSON print
       ip: Fix size_columns() for very large values
       ip: Fix size_columns() invocation that passes a 32-bit quantity

* Tue Mar 01 2022 jiangheng<jiangheng12@huawei.com> - 5.15.0-3
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: remove libcap-devel dependency

* Mon Feb 21 2022 jiangheng<jiangheng12@huawei.com> - 5.15.0-2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: remove libdb-devel dependency

* Fri Nov 26 2021 jiangheng <jiangheng12@huawei.com> - 5.15.0-1
- DESC: update to 5.15.0

* Mon Aug 02 2021 chenyanpanHW <chenyanpan@huawei.com> - 5.10.0-2
- DESC: delete -S git from autosetup, and delete BuildRequires git

* Tue Jan 26 2021 xihaochen<xihaochen@huawei.com> - 5.10.0-1
- Type:requirements
- ID:NA
- SUG:NA
- DESC: update iproute to 5.10.0

* Thu Dec 10 2020 zhouyihang <zhouyihang3@huawei.com> - 5.7.0-3
- Type:bugfix
- Id:NA
- SUG:NA
- DESC:modify fix of get_tc_lib err

* Thu Sep 24 2020 zhouyihang <zhouyihang3@huawei.com> - 5.7.0-2
- Type:bugfix
- Id:NA
- SUG:NA
- DESC:fix get_tc_lib err

* Wed Jul 22 2020 hanzhijun <hanzhijun1@huawei.com> - 5.7.0-1
- update to 5.7.0

* Mon Jan 20 2020 openEuler Buildteam <buildteam@openeuler.org> - 5.4.0-2
- fix maddr show and change proc to ipnetnsproc

* Tue Jan 14 2020 openEuler Buildteam <buildteam@openeuler.org> - 5.4.0-1
- update to 5.4.0

* Fri Oct 18 2019 openEuler Buildteam <buildteam@openeuler.org> - 5.2.0-2
- Type:bugfix
- Id:NA
- SUG:NA
- DESC:add the bugfix about iproute

* Thu Sep 19 2019 openEuler Buildteam <buildteam@openeuler.org> - 5.2.0-1
- Package init
